import QtQuick 1.0
//import qmlprocess 1.0
import quickwidgets 1.0

Rectangle {
    id: container
    width: parent.width
    height: parent.height
    color: "#202020"
    onVisibleChanged: {
        if (visible) dbuslist.run();
    }
    property color itemColor: "#000000"
    property color itemTextColor: "#ffffff"

    signal newPlaylist(string plist)

    ScrollBar {
        id: scrollbar
        width: plmodel.count*pldelegate.height > height ? 50: 0
        height: parent.height
        anchors.right: parent.right
        onDirection: {
            if (playlistview.currentIndex == -1) {
                playlistview.currentIndex = 0
            }
            if (dir == "up" && playlistview.currentIndex > 0) {
                playlistview.decrementCurrentIndex()
            } else if (dir == "down" && playlistview.currentIndex < playlistview.count-1) {
                    playlistview.incrementCurrentIndex()
            }
        }
    }

    ListView {
        id: playlistview
        model:  ListModel { id: plmodel }
        spacing: 2
        anchors.left: parent.left
        anchors.top: parent.top
        width:  parent.width-scrollbar.width
        height: parent.height
        delegate: Rectangle {
            id: pldelegate
            width: parent.width
            height: 48
            color: itemColor
            radius: 3
            Text {
	        horizontalAlignment: Text.AlignLeft
        	anchors.top: parent.top
        	anchors.left:  parent.left
                anchors.topMargin: 5
        	anchors.leftMargin:  5
                color: itemTextColor
                text:  playitem
                font.pixelSize: 15
            }
            MouseArea {
                anchors.fill: parent
                onClicked: {
                    color: "#6427c2ff"
                    dbusselect.selectPlaylist(playitem)
                }
            }
        }
    }
    Process {
        function setModel(stdout) {
            plmodel.clear()
            var rx = /"(.+)"/g;
            var val=stdout.match(rx)
            if (val) {
                var i = 0
                for (i=0; i < val.length;i++) {
                    plmodel.append({"playitem": val[i].replace(/"/g, "")})
                }
            }
        }

        id: dbuslist
        command: "sh -c \"dbus-send --type=method_call --print-reply --dest=ru.somebody.someplayer / ru.somebody.someplayer.playlists\""
        onCompleted: { setModel(stdout) }
        onFailed: {console.log(stderr)}
    }
    Process {
        function selectPlaylist(playlist) {
            var cmd = "sh -c \"dbus-send --type=method_call \
            --print-reply --dest=ru.somebody.someplayer / \
            ru.somebody.someplayer.select_playlist string:'%%%' \""
            command = cmd.replace("%%%", playlist)
            newPlaylist(playlist);
            run()
        }

        id: dbusselect
        command: ""
        onCompleted: {}
        onFailed: {}
    }

    Component.onCompleted: {dbuslist.run();}
}
