import QtQuick 1.0

Rectangle {
    id: container
    width: 50
    height: 100
    color: "black"
    signal direction(string dir)
    property color decorationColor: "#a0a0a0"
    property color barColor: "#000000"


    Rectangle {
        anchors.fill: parent
        anchors.margins: 2
        radius: 3
        color: barColor
        border {color: decorationColor; width: 1}
        Text {
            rotation: 270
            x: 18
            text:  ">"
            font.bold: true
            font.pixelSize: 20
            anchors.top: parent.top
            color: decorationColor
            smooth: true
        }
        Text {
            rotation: 90
            text:  ">"
            x: 18
            font.bold: true
            font.pixelSize: 20
            anchors.bottom: parent.bottom
            color: decorationColor
            smooth: true
        }
    }
    MouseArea {
        anchors.fill: parent
        onClicked: {
            if (mouseY < height/2) {
                direction("up")
            } else {
                direction("down")
            }
        }
    }
}
